import stiftUndCo.*;
public class StartZweiFarbwechsel
{	
	public static void main(String[] s)
	{
		ZweiFarbwechsel meinZweiFarbwechsel = new ZweiFarbwechsel();
		meinZweiFarbwechsel.fhreAus();		
	}
}


class ZweiFarbwechsel 
{ 
	private Bildschirm bildschirm;
	private BuntStift stift;
	private Maus maus;
	private Tastatur tastatur;
	
 	public void fhreAus()
	{/* Bereitstellen, Initialisierungsteil */
		bildschirm=new Bildschirm();
	  	stift=new BuntStift();
		maus = new Maus();
		tastatur = new Tastatur();
	  	/*Arbeiten, Aktionsteil */
		do
		{
			if (maus.istGedrueckt())
			{
					stift.bewegeBis(maus.hPosition(),maus.vPosition());
					stift.runter();
			} else
			{
				stift.hoch();
			}
			if (tastatur.wurdeGedrueckt())
			{	
				if (tastatur.zeichen()=='r')
				{
					stift.setzeFarbe(Farbe.ROT);
				} else
				{
					stift.setzeFarbe(Farbe.WEISS);
				}
			}
		} while (! maus.istRechtsGedrueckt());


    	/* Aufrumen, Abbauteil */
		tastatur.gibFrei();
		maus.gibFrei();
		stift.gibFrei();
		bildschirm.gibFrei();
	}

}

