// EreignisAnwendung.java

package stiftUndCo;

import java.awt.*;
import java.applet.Applet;


public  class EreignisAnwendung extends Bildschirm implements Runnable
{
	public Bildschirm bildschirm = null;
	public Maus maus = null;
	public Tastatur tastatur = null;
    public BuntStift stift = null;
	private Thread sonstigeEreignisse=null;
	public EreignisAnwendung (int breite, int hoehe, String s) 
	
	{
	  	super(breite,hoehe);
		this.setTitle(s);
		bildschirm = this;
	   	maus = new Maus(this);
	  	tastatur = new Tastatur(this);
		stift = new BuntStift(this);
	  	this.resize(breite, hoehe);
      	this.setLayout(new FlowLayout());
		// this.setLayout(null); //freie Ausrichtung von Buttons etc.
	  	this.setBackground(Farbe.WEISS);
	  	this.show();	
		sonstigeEreignisse=new Thread(this);
		sonstigeEreignisse.start();
	
		
	}
	
	public EreignisAnwendung(){
		this(400,300,"");}

	public void run()
	{
		while (true){
			try 
			{
				this.bearbeiteAndereEreignisse();
			}
			catch (Exception e)
			{;}
		try
		{
			sonstigeEreignisse.sleep(30);
		}
		catch (Exception e)
		{
		 sonstigeEreignisse.stop();
		}
		}
	}
	public void gibFrei()
	{	
		if (maus !=null) 
		{
			maus.gibFrei();
			maus=null;
		}
		if (tastatur != null) 
		{
			tastatur.gibFrei();
			tastatur=null;
		}
		bildschirm = null;
		if (stift !=null) 
		{
			stift.gibFrei();
			stift= null;
		}
		if (sonstigeEreignisse != null)
		{   
			sonstigeEreignisse.stop();
			sonstigeEreignisse=null;
		}
		super.gibFrei();
	}

	public void beenden()
	{
		this.gibFrei();
		dispose();
		try
		{
			System.exit(0);
		}
		catch (SecurityException se) {;}
	}
	
	public  void bearbeiteTaste(char pZeichen){;}

	public  void bearbeiteMausDruck(int pWoH, int pWoV){;}

	public  void bearbeiteMausLos(int pWoH, int pWoV){;}

	public  void bearbeiteMausBewegt(int pWohinH, int pWohinV){;}

	public  void bearbeiteSpezialKlick(int pWoH, int pWoV){;}

	public  void bearbeiteAndereEreignisse(){;}
	
	public Bildschirm bildschirm()
	{
		return bildschirm;
	}
	public Tastatur tastatur()
	{
		return tastatur;
	}
	public Maus maus()
	{
		return maus;
	}
	public BuntStift stift()
	{
		return stift;
	}
	
	

	public boolean handleEvent(Event ev)
	{
		merkeevent=ev;
	
		switch(ev.id)
		{	
		
		case Event.WINDOW_DESTROY:
			this.beenden();
			return true;
		
	
		case Event.MOUSE_DOWN:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 zmausunten=true;
			 	if (ev.modifiers==Event.META_MASK)
			 	{
			 		bearbeiteSpezialKlick(ev.x, ev.y);
			 	}
			 	else
				{
					bearbeiteMausDruck(ev.x, ev.y);
				}
			 return true;

		case Event.MOUSE_DRAG:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 zmausunten=true;
			 bearbeiteMausBewegt(ev.x, ev.y);
			 return true;

		case Event.MOUSE_EXIT:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 bearbeiteMausBewegt(ev.x, ev.y);
			 return true;
	
		case Event.MOUSE_MOVE:
			 zmausx=ev.x;
			 zmausy=ev.y;
		     bearbeiteMausBewegt(ev.x, ev.y);
			 return true;

		case Event.MOUSE_UP:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 zmausunten=false;
			 bearbeiteMausLos(ev.x, ev.y);
			 return true;

		case Event.MOUSE_ENTER:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 bearbeiteMausBewegt(ev.x, ev.y);
			 return true;

		case Event.KEY_PRESS:
			 zzeichen=ev.key;
			 
			

		case Event.KEY_ACTION:
			 zzeichen=ev.key;
			  if (ev.target==this)
			 {  bearbeiteTaste((char)ev.key);
				return true;}
			 else
			 {return false;}

		case Event.ACTION_EVENT:
			 return action(ev, ev.arg);
    

		default:
			return super.handleEvent(ev);
		}
	}
	
	
	
}

