package stiftUndCo;

import java.awt.*;
import java.applet.*;





public class Stift 
{
  // Stiftmodi	als Klassenkonstante
  public static final int NORMALMODUS=0;
  public static final int RADIERMODUS=1;
  public static final int WECHSELMODUS=2;
  
 
  //Image kenntb; 
  private Bildschirm kenntBi=null; // Ein Stift mu seinen Arbeitsbereich kennen
  double zstiftx=0,zstifty=0;	// Stiftposition
  boolean zhoch=true; // Stiftzustand
  double zwinkel=0;	// Stiftrichtung
  int zschreibmodus=NORMALMODUS; //	  Normalmodus 
  
 
   
  
  public Bildschirm	bildschirm () {
   return kenntBi;
  }

  public Graphics g()
  {
	  return kenntBi.aktuellerGrafikkontext();
  }

  public Stift(){
	kenntBi=Bildschirm.hauptbildschirm;
   	this.setzeStandard();
  }

  public Stift(Bildschirm bi) 
  {
	kenntBi=bi;
   	this.setzeStandard();	
  }

  public void bewegeBis(double px, double py) 
  {
	if (zhoch==false)
	{ 
	   this.zeichneLinie(px,py,zstiftx,zstifty); 	   
	} 
	this.zstiftx=px;
	this.zstifty=py;
  }

  public void bewegeUm(double pl)
  {
	  double w;
      double x,y;
	  w = zwinkel*Math.PI/180;
      x=zstiftx + pl* Math.cos(w);
      y=zstifty - pl* Math.sin(w);
      if ( zhoch == false) { zeichneLinie(zstiftx,zstifty,x,y); }
      zstiftx = x;
      zstifty = y;
  }
  
  public void dreheBis(double pw)
  {
  zwinkel= pw;
  while (zwinkel <0) {zwinkel=zwinkel+360;}
  while (zwinkel >=360 ) {zwinkel=zwinkel-360;}
  }

  public void dreheUm(double pw)
  {
  zwinkel=zwinkel+pw;
  while (zwinkel <0) {zwinkel=zwinkel+360;}
  while (zwinkel >=360 ) {zwinkel=zwinkel-360;}
  }
  
  public void schreibe(String ps)
  {	
	Graphics gr=kenntBi.aktuellerGrafikkontext();
	setzeZustand();
	
	if (gr != null) {

    gr.drawString(ps,(int)zstiftx,(int)zstifty);
	
	//kenntBi.repaint();
    zstiftx=zstiftx+gr.getFontMetrics().stringWidth(ps);
	
	}
  }
   public void schreibe(char pt)
  {	
	   String s=String.valueOf(pt);
	   this.schreibe(s);
    
   } 

  public void hoch ()
  {
    zhoch=true; 
  }

  public void runter ()
  {
    zhoch=false;
  }

  public void normal () 
  {
	  zschreibmodus=NORMALMODUS;
  }

  public void radiere () 
  {
	  zschreibmodus=RADIERMODUS;
  }

  public void wechsle () 
  {
	  zschreibmodus=WECHSELMODUS;
  }

  public double hPosition()
  {
	  return zstiftx;
  }
  
  public double vPosition()
  {
	  return zstifty;
  }

  public double winkel()
  {
	  return zwinkel;
  }




public void zeichneRechteck(double pbreite, double phoehe)
{
 int x1,y1,x2,y2;
 Graphics gr=kenntBi.aktuellerGrafikkontext();
  x1=(int)zstiftx;x2=(int)pbreite;
  y1=(int)zstifty;y2=(int)phoehe;
  setzeZustand();
  if (gr != null) {

  gr.drawRect(x1,y1,x2,y2);
  
  
  }
}

public void zeichneKreis(double pradius)
{
	int x1,y1,d;
     Graphics gr=kenntBi.aktuellerGrafikkontext();
    x1=(int)(zstiftx-pradius);
    y1=(int)(zstifty-pradius);
    d=(int)(2*pradius);
	setzeZustand();
	if (gr != null) {

	gr.drawOval(x1,y1,d,d);
	
	}
}
 public void setzeStandard()
  {
  zstiftx=0;zstifty=0;	// Stiftposition
  zhoch=true; // Stiftzustand
  zwinkel=0;	// Stiftrichtung
  this.normal(); //	  Normalmodus 
  
  }


  public void setzeZustand()
  {   Graphics gr;
      if (kenntBi!=null)
	  {
		gr=kenntBi.aktuellerGrafikkontext();
	    if (!(gr==null)) {
	    if (zschreibmodus==RADIERMODUS) 
		{ 
			gr.setColor(kenntBi.hintergrundFarbe());
	        gr.setPaintMode();
		} else
     	if (zschreibmodus==NORMALMODUS)
		{
			gr.setColor(Color.black);
			gr.setPaintMode(); 
		}  else 
		{ 
			gr.setColor(Color.black);
			gr.setXORMode(kenntBi.hintergrundFarbe()); 
		}
		}
		gr.setFont(Schrift.STANDARDSCHRIFT);
	  }
  }
  
  public void zeichneLinie(double x1,double y1,double x2,double y2) 
  {
	  Graphics gr=kenntBi.aktuellerGrafikkontext();
      setzeZustand();
      if (gr != null) 
	  {
		gr.drawLine((int)x1,(int)y1,(int)x2,(int)y2);
	  }
  }

  public void gibFrei()
  {
	  kenntBi=null;
	  System.gc();
  }

}

