
package stiftUndCo;

import java.awt.*;
import java.applet.*;
/**
@author Georg Dick
@version 22.7.98

 */
public class BuntStift extends Stift
{
  private String zaktuellfont =	Schrift.STANDARDSCHRIFTART;
  private int zschriftstil=	Schrift.STANDARDSTIL;
  private int zschriftgroesse=Schrift.STANDARDGROESSE;
  private Font zschriftart=Schrift.STANDARDSCHRIFT;
  private Color zfarbe = Color.black;
  private int zlinienbreite=1;	   // noch ohne Bedeutung, da Java keine Breiten
								   // untersttzt
  private int zmuster=Muster.DURCHSICHTIG;
  

  public BuntStift(){
	  super ();}
   public BuntStift(Malflaeche b)
  {
	  super (b);	   
  }  
  public void gibFrei()
  {
	 zschriftart=null;
	 zfarbe = null;
	 super.gibFrei();	 
  }  
  public void setzeFarbe(Color farbe) 
  {
	zfarbe=farbe;
  }  
  public Color farbe()
  {
	  return zfarbe;
  }

  public void setzeLinienBreite(int pb)
  {
	  zlinienbreite=pb;
  }
  public void setzeFuellMuster(int muster) {
	  zmuster=muster;
  }  
  public void setzeSchrift(String art, int stil, int groesse){
	   zaktuellfont=art;
	   zschriftgroesse=groesse;
	   zschriftstil= stil;
  }  
  public void setzeSchriftArt(String schriftart) 
  {
	zaktuellfont=schriftart;
  }  
  public void setzeSchriftGroesse(int schriftgroesse) {
	zschriftgroesse=schriftgroesse;
  }  
  public void setzeSchriftStil(int schriftstil) {
	zschriftstil= schriftstil;
  }  
  public void setzeStandard()
  {
  zstiftx=0;zstifty=0;	// Stiftposition
  zhoch=true; // Stiftzustand
  zwinkel=0;	// Stiftrichtung
  
  zschreibmodus=NORMALMODUS; //	  Normalmodus 
  zaktuellfont =Schrift.STANDARDSCHRIFTART;
  zschriftstil=	Schrift.STANDARDSTIL;
  zschriftgroesse=Schrift.STANDARDGROESSE;
  zschriftart=Schrift.STANDARDSCHRIFT;
  
  zfarbe = Color.black;
  zlinienbreite=1;
  zmuster = Muster.DURCHSICHTIG;
  }  
 protected void setzeZustand(Graphics g)
  {
	 if ((g!=null)) 
	  {
		
		if (zschreibmodus==NORMALMODUS)
		{
			g.setColor(zfarbe);g.setPaintMode(); 
		}	else 
		if (zschreibmodus==RADIERMODUS) 
		{ 
			g.setColor(bildschirm().hintergrundFarbe());
			g.setPaintMode();
		}	else
		{ 
			g.setColor(zfarbe);
			g.setXORMode(bildschirm().hintergrundFarbe()); 
		}
	    zschriftart=new Font(zaktuellfont,zschriftstil,zschriftgroesse);
		g.setFont(zschriftart);
	  }
	
 } 
public void zeichneKreis(double pradius)
{
	int x1,y1,d;
	gr=this.g();
	x1=(int)(zstiftx-pradius);
	y1=(int)(zstifty-pradius);
	d=(int)(2*pradius);
	if (zmuster==Muster.DURCHSICHTIG)
	{
		setzeZustand(gr);
		gr.drawOval(x1,y1,d,d);
	    
	}
	else
	{	if (zmuster==Muster.GEFUELLT)
		{
		setzeZustand(gr);
		gr.fillOval(x1,y1,d,d);
		
		}
	}
  gr=null;
}
public void zeichneRechteck(double pbreite, double phoehe)
{

  int x1,y1,x2,y2;
  gr = this.g();
  x1=(int)zstiftx;x2=(int)pbreite-1;
  y1=(int)zstifty;y2=(int)phoehe-1;
  if (zmuster==Muster.DURCHSICHTIG)
	{
	  setzeZustand(gr);
	  gr.drawRect(x1,y1,x2,y2);
	  
	 
	}
  else
  {		if (zmuster==Muster.GEFUELLT)
	{
	  setzeZustand(gr);
	  gr.fillRect(x1,y1,x2+1,y2+1);
	  /* fillrect zeichnet kleinere Rechtecke als drawrect ! */
	  
	}
  }
  gr=null;
}
}