import stiftUndCo.*;
//
//
// Uhr
//
//
public class Uhr 
{
	private Bildschirm b;
	private BuntStift stift;
	private double stunde,minute,sekunde,
			stundeneu,minuteneu,sekundeneu,radius,xm,ym;
	public Uhr(Bildschirm b)
	{
		this.b=b;
		stift = new BuntStift(b);
		stunde=Hilfe.stunde();
		minute=Hilfe.minute();
		sekunde=Hilfe.sekunde();
		if (b.hoehe() < b.breite()) { radius = b.hoehe()/2;}
		else {radius = b.breite()/2;}
		xm=b.breite()/2;
		ym=b.hoehe()/2;

	}
	public synchronized void  weiter()
	{
		stundeneu=Hilfe.stunde();
		minuteneu=Hilfe.minute();
		sekundeneu=Hilfe.sekunde();
		this.loescheZeiger();
		this.zeigeZeiger();
		stunde=stundeneu;
		minute=minuteneu;
		sekunde=sekundeneu;
	}
	public void zeige()
	{
		stift.normal();
		stift.bewegeBis(xm,ym);
		stift.zeichneKreis(radius);
		zeigeZeiger();
	
	}
	public void zeigeZeiger()
	{
		stift.normal();
		stift.hoch();
		stift.bewegeBis(xm,ym);
		stift.runter();
		stift.dreheBis(-sekunde*6+90);
		stift.bewegeUm(radius*0.9);
		stift.hoch();
		stift.bewegeBis(xm,ym);
		stift.runter();
		stift.dreheBis(-minute*6+90);
		stift.bewegeUm(radius*0.8);
		stift.hoch();
		stift.bewegeBis(xm,ym);
		stift.runter();
		stift.dreheBis(-stunde*30+90);
		stift.bewegeUm(radius*0.8);
		stift.hoch();


	}
	public void loescheZeiger()
	{
		stift.radiere();
		stift.hoch();
		if (sekundeneu != sekunde )
		{
		stift.bewegeBis(xm,ym);
		stift.runter();
		stift.dreheBis(-sekunde*6+90);
		stift.bewegeUm(radius*0.9);
		stift.hoch();
		}
		if (minuteneu != minute )
		{ 
		stift.bewegeBis(xm,ym);
		stift.runter();
		stift.dreheBis(-minute*6+90);
		stift.bewegeUm(radius*0.8);
		stift.hoch();
		}
		if ( stundeneu != stunde )
		{
		stift.bewegeBis(xm,ym);
		stift.runter();
		stift.dreheBis(-stunde*30+90);
		stift.bewegeUm(radius*0.8);
		stift.hoch();
		}

	}




}

