import stiftUndCo.*;
import java.awt.*;
public class Rechteck extends Figur
{
	double zBreite, zHoehe;
	public Rechteck (double pBreite,double  pHoehe,double  pHPosition,double  pVPosition, Color pFarbe)
	{
		super(pHPosition, pVPosition, pFarbe);
		zBreite = pBreite;
		zHoehe = pHoehe;
	}

	public void zeichneDich()
	{
		this.stift().bewegeBis(this.hPosition(),this.vPosition());
		this.stift().normal();
		this.stift().zeichneRechteck(zBreite, zHoehe);
	}

	public void breiteAendern (double pdBreite)
	{
		zBreite = zBreite + pdBreite;
	}

	public void HoeheAendern (double pdHoehe)
	{
		zHoehe = zHoehe + pdHoehe;
	}

	public void loescheDich()
	{
		this.stift().bewegeBis(this.hPosition(), this.vPosition());
		this.stift().radiere();
		this.stift().zeichneRechteck(zBreite, zHoehe);
	}

	public double breite()
	{
		return zBreite;
	}

	public double hoehe()
	{
		return zHoehe;
	}

	public boolean getroffen (double pHPosition, double pVPosition)
	{
		return (pHPosition >= zHPosition) && (pHPosition <= zHPosition + zBreite) && (pVPosition >= zVPosition)
                && (pVPosition <= zVPosition + zHoehe);
	}

}