import stiftUndCo.*;
import java.awt.*;

public class Schlafwagen extends Waggon
{
	Quadrat fenster1, fenster2, fenster3, fenster4;
	Kreis	rad1, rad2, rad3, rad4;
	Rechteck aufbau, radkasten;
	public Schlafwagen (double pHPosition,double  pVPosition)
	{
		super(pHPosition, pVPosition);
		fenster1= new Quadrat(10, pHPosition + 5, pVPosition - 25, Farbe.GRUEN);
		fenster2= new Quadrat(10, pHPosition + 20, pVPosition - 25, Farbe.GRUEN);
		fenster3 = new Quadrat(10, pHPosition + 35, pVPosition - 25, Farbe.GRUEN);
		fenster4 = new Quadrat(10, pHPosition + 50, pVPosition - 25, Farbe.GRUEN);
		rad1 = new Kreis(5, pHPosition + 10, pVPosition, Farbe.ROT);
		rad2 = new Kreis(5, pHPosition + 25, pVPosition, Farbe.ROT);
		rad3 = new Kreis(5, pHPosition + 40, pVPosition, Farbe.ROT);
		rad4 = new Kreis(5, pHPosition + 55, pVPosition, Farbe.ROT);
		aufbau = new Rechteck(65, 25, pHPosition, pVPosition - 30, Farbe.BLAU);
		radkasten = new Rechteck(65, 5, pHPosition, pVPosition - 5, Farbe.BLAU);
		
	}

	public void zeichneDich()
	{
		super. zeichneDich();
		fenster1.zeichneDich();
		fenster2.zeichneDich();
		fenster3.zeichneDich();
		fenster4.zeichneDich();
		rad1.zeichneDich();
		rad2.zeichneDich();
		rad3.zeichneDich();
		rad4.zeichneDich();
		aufbau.zeichneDich();
		radkasten.zeichneDich();
	}

	public void loescheDich()
	{
		super. loescheDich();
		fenster1.loescheDich();
		fenster2.loescheDich();
		fenster3.loescheDich();
		fenster4.loescheDich();
		rad1.loescheDich();
		rad2.loescheDich();
		rad3.loescheDich();
		rad4.loescheDich();
		aufbau.loescheDich();
		radkasten.loescheDich();
	}

	public void bewegeBis (double pHPosition,double  pVPosition)
	{
		super. bewegeBis(pHPosition, pVPosition);
		fenster1.bewegeBis(pHPosition + 5, pVPosition - 25);
		fenster2.bewegeBis(pHPosition + 20, pVPosition - 25);
		fenster3.bewegeBis(pHPosition + 35, pVPosition - 25);
		fenster4.bewegeBis(pHPosition + 50, pVPosition - 25);
		rad1.bewegeBis(pHPosition + 10, pVPosition);
		rad2.bewegeBis(pHPosition + 22, pVPosition);
		rad3.bewegeBis(pHPosition + 40, pVPosition);
		rad4.bewegeBis(pHPosition + 55, pVPosition);
		aufbau.bewegeBis(pHPosition, pVPosition - 30);
		radkasten.bewegeBis(pHPosition, pVPosition - 5);
	}

	public double laenge()
	{
		return 65;
	}

	public void gibFrei()
	{
		radkasten.gibFrei();
		aufbau.gibFrei();
		rad4.gibFrei();
		rad3.gibFrei();
		rad2.gibFrei();
		rad1.gibFrei();
		fenster4.gibFrei();
		fenster3.gibFrei();
		fenster2.gibFrei();
		fenster1.gibFrei();
		super. gibFrei();
	}
}
