import stiftUndCo.*;
public class StartBallInnen
{	
	public static void main(String[] s)
	{
     		BallInnenProgramm meinBallInnenProgramm = new BallInnenProgramm();
			meinBallInnenProgramm.fhreAus();		
	}
}


class BallInnenProgramm 
{ 
	private class BallInnen
	{
		
		public BallInnen()
		{
			stift.bewegeBis(bildschirm.breite()/2,bildschirm.hoehe()/2);
		}

		public void zeichne()
		{
		  stift.normal();
		  stift.zeichneKreis(20);
		}

		public void lsche()
		{
		 stift.radiere();
		 stift.zeichneKreis(20);
		}

		public void bewege()
		{
			this.lsche();
			stift.bewegeUm(1);
			this.zeichne();
			if (stift.hPosition()>=bildschirm.breite()-20)
			{
				stift.dreheBis(180);
			}
			if (stift.hPosition()< 20)
			{
				stift.dreheBis(0);
			}
		}
		public void gibFrei()
		{
		  this.lsche();
		  stift.gibFrei();
		}
	}
	private Bildschirm bildschirm;
	private BuntStift stift;
	private Maus maus;
	private Tastatur tastatur;
	private BallInnen BallInnen;
	
 	public void fhreAus()
	{/* Bereitstellen, Initialisierungsteil */
		bildschirm=new Bildschirm();
		stift=new BuntStift();
	  	maus = new Maus();
		tastatur = new Tastatur();
		BallInnen=new BallInnen();
		BallInnen.zeichne();
	  	/*Arbeiten, Aktionsteil */
		do
		{
			BallInnen.bewege();
		} while (! maus.istRechtsGedrueckt());


    	/* Aufrumen, Abbauteil */
		BallInnen.gibFrei();
		stift.gibFrei();
		tastatur.gibFrei();
		maus.gibFrei();
		bildschirm.gibFrei();
	}

}

