import stiftUndCo.*;
public class StartFarbwechsel
{	
	public static void main(String[] s)
	{
		Farbwechsel meinFarbwechsel = new Farbwechsel();
		meinFarbwechsel.fhreAus();		
	}
}


class Farbwechsel 
{ 
	private Bildschirm bildschirm;
	private BuntStift stift;
	private Maus maus;
	private Tastatur tastatur;
	
 	public void fhreAus()
	{/* Bereitstellen, Initialisierungsteil */
		bildschirm=new Bildschirm();
	  	stift=new BuntStift();
		maus = new Maus();
		tastatur = new Tastatur();
	  	/*Arbeiten, Aktionsteil */
		do
		{
			if (maus.istGedrueckt())
			{
					stift.bewegeBis(maus.hPosition(),maus.vPosition());
					stift.runter();
			} else
			{
				stift.hoch();
			}
			if (tastatur.wurdeGedrueckt())
			{
				stift.setzeFarbe(Farbe.ROT);
			}
		} while (! maus.istRechtsGedrueckt());


    	/* Aufrumen, Abbauteil */
		tastatur.gibFrei();
		maus.gibFrei();
		stift.gibFrei();
		bildschirm.gibFrei();
	}

}

