import stiftUndCo.*;
public class StartVielFarbwechsel
{	
	public static void main(String[] s)
	{
		VielFarbwechsel meinVielFarbwechsel = new VielFarbwechsel();
		meinVielFarbwechsel.fhreAus();		
	}
}


class VielFarbwechsel 
{ 
	private Bildschirm bildschirm;
	private BuntStift stift;
	private Maus maus;
	private Tastatur tastatur;
	
 	public void fhreAus()
	{/* Bereitstellen, Initialisierungsteil */
		bildschirm=new Bildschirm();
	  	stift=new BuntStift();
		maus = new Maus();
		tastatur = new Tastatur();
	  	/*Arbeiten, Aktionsteil */
		do
		{
			if (maus.istGedrueckt())
			{
					stift.bewegeBis(maus.hPosition(),maus.vPosition());
					stift.runter();
			} else
			{
				stift.hoch();
			}
			if (tastatur.wurdeGedrueckt())
			{
				switch (tastatur.zeichen())
				{
				case 'r' :stift.setzeFarbe(Farbe.ROT);
							break;
				case 'g' :stift.setzeFarbe(Farbe.GRN);
							break;
				case 'b' :stift.setzeFarbe(Farbe.BLAU);
							break;
				case 's' :stift.setzeFarbe(Farbe.SCHWARZ);
							break;
				case 'w' :stift.setzeFarbe(Farbe.WEISS);
							break;
				default:;
							
				} 
			}
		} while (! maus.istRechtsGedrueckt());


    	/* Aufrumen, Abbauteil */
		tastatur.gibFrei();
		maus.gibFrei();
		stift.gibFrei();
		bildschirm.gibFrei();
	}

}

