package stiftUndCo;

import java.awt.*;
import java.applet.*;


public class Bildschirm extends Frame
{
	public static Bildschirm hauptbildschirm=null;
	protected int zmausx=0,zmausy=0;
	protected boolean zmausunten=false;
	protected boolean zrechtsunten=false;
	private Color zhintergrundfarbe=Farbe.WEISS;
	private int zhoehe=0,zbreite=0;
	protected Graphics grafikKontext=this.getGraphics();
	protected Graphics hggrafikkontext=null;
	protected int zzeichen=0;
	protected Event merkeevent=null;
	protected Image hintergrundbild=null;
	protected boolean zhintergrundmodus=false;
	


	public Bildschirm (int breite, int hoehe) 
	{
	  super();
	  zbreite=breite+this.insets().left+this.insets().right;
	  zhoehe=hoehe+this.insets().top+this.insets().bottom;
	  this.resize(zbreite,zhoehe);
      this.setLayout(new FlowLayout());
	  //this.setLayout(null);
	  this.setBackground(zhintergrundfarbe);
	  this.show();
	  this.registriere();
	  this.requestFocus();	 
	  hintergrundbild = createImage(size().width,size().height);
	  zhintergrundmodus=false;  
	}

	public Bildschirm (int breite, int hoehe, String titel) 
	{
	  this(breite,hoehe);
	  this.setTitle(titel);	  
	}

	public void setzeHintergrundmodus(boolean ein)
	{
		if (ein)
		{
			// neues Hintergrundbild erzeugen
			
			
			hggrafikkontext= hintergrundbild.getGraphics();
			this.setzeHintergrundFarbe(zhintergrundfarbe);
			// kopiere Vordergrund auf Hintergrund
            // geht wohl nicht! 			
		}
		else
		{
			// kopiere gegebenenfalls Hintergund auf Vordergrund
            // wirklich ntig ?
			if (hintergrundbild != null)
			grafikKontext.drawImage(hintergrundbild,0,0,this);
			// gib Hintergrundbild frei
			hintergrundbild=null;
		}
		zhintergrundmodus=ein;
	}

	public void setzeTitel(String titel) 
	{
		this.setTitle(titel);		
	}

	public Bildschirm(){
		this(400,300,"Bildschirm");
	}
	private void registriere(){
		if (hauptbildschirm==null) {hauptbildschirm=this;}
	}
	 public Event aktion(){
		 Event e=merkeevent;
		 merkeevent=null;

     return e;	
	}
	 

	protected Graphics g() {
	 return grafikKontext;
	}

	public Graphics aktuellerGrafikkontext()
	{
		if (zhintergrundmodus)
		{
		     return hggrafikkontext;
		} else
		{
		     return grafikKontext;
		}
	}
    

	public synchronized void addNotify()
	{
		super.addNotify();
		grafikKontext = this.getGraphics();
	}

	public synchronized void removeNotify()
	{
		super.removeNotify();
		grafikKontext = null;
	}

    public void update (Graphics g) 
	{
		this.paint(g);
	}

	public void setzeHintergrundFarbe(Color c) 
	{
		zhintergrundfarbe=c;
		if ( ! zhintergrundmodus)
		{
			this.setBackground(zhintergrundfarbe);
			this.resize(this.size().width-1,this.size().height-1);
			this.resize(this.size().width+1,this.size().height+1);
		} else
		{
			
			hggrafikkontext.setColor(zhintergrundfarbe);
			hggrafikkontext.fillRect(0,0,size().width,size().height);
			grafikKontext.drawImage(hintergrundbild,0,0,this);
			
		}
	}

	public void loescheAlles() 
	{ 		 
		if ( ! zhintergrundmodus)
		{
			this.setBackground(zhintergrundfarbe);
			this.resize(this.size().width-1,this.size().height-1);
			this.resize(this.size().width+1,this.size().height+1);
		} else
		{
			
			hggrafikkontext.setColor(zhintergrundfarbe);
			hggrafikkontext.fillRect(0,0,size().width,size().height);
			grafikKontext.drawImage(hintergrundbild,0,0,this);
		}
	}

	public Color hintergrundFarbe()
	{
		return zhintergrundfarbe ;
	}
	
	public int breite()
	{
		return this.size().width-insets().left-insets().right;
	}
	
	public int hoehe()
	{
	   	return this.size().height-insets().top-insets().bottom;
	}
	
	public void aktualisiere()
	{
		if (zhintergrundmodus)
		{
		    grafikKontext.drawImage(hintergrundbild,0,0,this);
		}
	}
	protected  boolean mausUnten()
	{
		return zmausunten;
	}
	protected boolean mausRechtsUnten()
	{
		return zmausunten && zrechtsunten;
	}

	protected int mausHPosition()
	{
		return zmausx;
	}


	protected int mausVPosition()
	{
		return zmausy ;
	}

	protected boolean tasteGedrueckt(){
		return zzeichen!=0;
	}
	protected int zeichenCode()
	{	
		int hilf;
		hilf=zzeichen;
	 	zzeichen=0;
		return hilf;
	}

	public void gibFrei()
	{
		if (this == hauptbildschirm) 
		{
			hauptbildschirm=null;
		}	
		zhintergrundfarbe=null;
		grafikKontext=null;
		merkeevent=null;
		this.dispose();
		System.exit(0);
	}
	public void bearbeiteFensterverndert()
	{
		//System.out.println("nderung");
		Image hilf=createImage(size().width,size().height);
		hilf.getGraphics().drawImage(hintergrundbild,0,0,this);
		hintergrundbild=null;
		hggrafikkontext= null;
		System.gc();
		hintergrundbild=hilf;
		hggrafikkontext= hintergrundbild.getGraphics();
		hilf=null;
	}

	public boolean handleEvent(Event ev)
	{
		
		merkeevent=ev;
		switch(ev.id)
		{
		case Event.WINDOW_DESTROY:
			
			return true;
		case Event.WINDOW_DEICONIFY:
			this.bearbeiteFensterverndert();
			return true;
		case Event.WINDOW_MOVED:
		    this.bearbeiteFensterverndert();
			return true;
		case Event.WINDOW_ICONIFY:
			this.bearbeiteFensterverndert();
			return true;
			
		case Event.MOUSE_DOWN:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 zmausunten=true;
			 if (ev.modifiers==Event.META_MASK)
				{ zrechtsunten=true ;}
			 else
				{ zrechtsunten=false ;}
			 return true;
		case Event.MOUSE_DRAG:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 zmausunten=true;
			 if (ev.modifiers==Event.META_MASK)
				{ zrechtsunten=true ;}
			 else
				{ zrechtsunten=false ;}
			 return true;
		case Event.MOUSE_EXIT:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 return true;
	
		case Event.MOUSE_MOVE:
			 zmausx=ev.x;
			 zmausy=ev.y;
		     return true;

		case Event.MOUSE_UP:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 zmausunten=false;
			 zrechtsunten=false;
			 return true;

		case Event.MOUSE_ENTER:
			 zmausx=ev.x;
			 zmausy=ev.y;
			 return true;

		case Event.KEY_PRESS:
			 zzeichen=ev.key;
			 return true;

		case Event.KEY_ACTION:
			 zzeichen=ev.key;
			 return true;
	
		case Event.ACTION_EVENT:
			 merkeevent=ev;
			 return false;
			 

		default:
			return super.handleEvent(ev);
		}
	}
	
}

