package stiftUndCo;

import java.awt.*;
import java.applet.*;


public class Tastatur
{
 Bildschirm bildschirm=null;
 public Tastatur() {
	 bildschirm=Bildschirm.hauptbildschirm;
 }
 public Tastatur(Bildschirm b){
	 bildschirm=b;
 }

 public boolean wurdeGedrueckt(){
	 if (bildschirm != null)
	 {
	 	  return bildschirm.tasteGedrueckt();}
	 else
		 return false;
 }
					
 public char zeichen() {
	 if (bildschirm != null) {
	 int merke=bildschirm.zeichenCode();
	 char ergebnis=(char)merke;
	 switch (merke){
	 case 27:ergebnis=Zeichen.ESC;break;
	 case Event.DOWN:ergebnis=Zeichen.PFEILUNTEN;break;	 
	 case Event.END: ergebnis=Zeichen.ENDE	;break;
	 case Event.F1: ergebnis=Zeichen.F1	;break;
	 case Event.F2: ergebnis=Zeichen.F2	;break;
	 case Event.F3: ergebnis=Zeichen.F3	;break;
	 case Event.F4: ergebnis=Zeichen.F4	;break;
	 case Event.F5: ergebnis=Zeichen.F5	;break;
	 case Event.F6: ergebnis=Zeichen.F6	;break;
	 case Event.F7: ergebnis=Zeichen.F7	;break;
	 case Event.F8: ergebnis=Zeichen.F8	;break;
	 case Event.F9: ergebnis=Zeichen.F9	;break;
	 case Event.F10: ergebnis=Zeichen.F10	;break;
	 case Event.F11: ergebnis=Zeichen.F11	;break;
	 case Event.F12: ergebnis=Zeichen.F12	;break;
	 case Event.HOME:ergebnis=Zeichen.POS1;break;	
     case Event.LEFT:ergebnis=Zeichen.PFEILLINKS;break;	
     case Event.PGDN:ergebnis=Zeichen.BILDUNTEN;break;	
     case Event.PGUP:ergebnis=Zeichen.BILDAUF;break;	
     case Event.RIGHT:ergebnis=Zeichen.PFEILRECHTS;break;	
     case Event.UP:ergebnis=Zeichen.PFEILOBEN;break;	
	 }
	 

	 return ergebnis;
	 }
	 else return ' ';
 }
 public void gibFrei()
 {
	 bildschirm=null;
 }
}




