
package stiftUndCo;

// EreignisAnwendung.java

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;

/**
@author Georg Dick
@version 10.8.98

 */
public  class EreignisAnwendung extends Anwendung implements Ereignisbearbeitung,Runnable,KeyListener, MouseListener,MouseMotionListener,WindowListener,ComponentListener
{
	private Thread sonstigeEreignisse=null;

	public  EreignisAnwendung(){
		this(400,300,"");
		}
	public EreignisAnwendung (int breite, int hoehe, String s) 
	
	{
	  	super(breite,hoehe,s);
	}

	public void fhreAus()
	{
		bildschirm.addMouseListener(this);
		bildschirm.addMouseMotionListener(this);
		bildschirm.addKeyListener(this);
		bildschirm.addWindowListener(this);
		bildschirm.addComponentListener(this);
		if (bildschirm.laeuftInApplet())
		{  sonstigeEreignisse=new Thread(this); 
		 	sonstigeEreignisse.start();	 }
		else 
		{
		bildschirm.addAndereEreignisseListener(this);
		}
	}
	public void init(){;}
	public  void bearbeiteAndereEreignisse(){;}
	public  void bearbeiteMausBewegt(int pWohinH, int pWohinV){;}
	public  void bearbeiteMausGezogen(int pWohinH, int pWohinV){;}
	public  void bearbeiteMausDruck(int pWoH, int pWoV){;}
	public  void bearbeiteMausDruckRechts(int pWoH, int pWoV){;}
	public  void bearbeiteMausLos(int pWoH, int pWoV){;}
	public  void bearbeiteMausLosRechts(int pWoH, int pWoV){;}
	public  void bearbeiteMausKlick(int pWoH, int pWoV){;}
	public  void bearbeiteSpezialKlick(int pWoH, int pWoV){;}
	public  void bearbeiteTaste(char pZeichen){;}
	public void bearbeiteFensterBewegt(){;}
	public void beenden()
	{
		this.gibFrei();
	}
	
	public void gibFrei()
	{	
		if (sonstigeEreignisse != null)
		{   
			sonstigeEreignisse.stop();
			sonstigeEreignisse=null;
		}
		super.gibFrei();
	}
	
	
	public void run()
	{
	 while (true){
				 try 
			{
				this.bearbeiteAndereEreignisse();
			}
			catch (Exception e)
			{;}
		

		  try
		{
			sonstigeEreignisse.sleep(30);
		}
		catch (Exception e)
		{
		 sonstigeEreignisse.stop();
		}
		}
	}
	

    public void keyTyped(KeyEvent e)
	{
	   char zeichen= e.getKeyChar();
	 if ((zeichen==KeyEvent.CHAR_UNDEFINED)
		 && (e.getKeyCode() != KeyEvent.VK_UNDEFINED))
	 {	  
		 switch (e.getKeyCode())
		 {
	      case 27:zeichen=Zeichen.ESC;break;
	      case Event.DOWN:zeichen=Zeichen.PFEILUNTEN;break;	 
	      case Event.END: zeichen=Zeichen.ENDE	;break;
	      case Event.F1: zeichen=Zeichen.F1	;break;
	      case Event.F2: zeichen=Zeichen.F2	;break;
	      case Event.F3: zeichen=Zeichen.F3	;break;
	      case Event.F4: zeichen=Zeichen.F4	;break;
	      case Event.F5: zeichen=Zeichen.F5	;break;
	      case Event.F6: zeichen=Zeichen.F6	;break;
	      case Event.F7: zeichen=Zeichen.F7	;break;
	      case Event.F8: zeichen=Zeichen.F8	;break;
	      case Event.F9: zeichen=Zeichen.F9	;break;
	      case Event.F10: zeichen=Zeichen.F10	;break;
	      case Event.F11: zeichen=Zeichen.F11	;break;
	      case Event.F12: zeichen=Zeichen.F12	;break;
	      case Event.HOME:zeichen=Zeichen.POS1;break;	
	      case Event.LEFT:zeichen=Zeichen.PFEILLINKS;break;	
	      case Event.PGDN:zeichen=Zeichen.BILDUNTEN;break;	
	      case Event.PGUP:zeichen=Zeichen.BILDAUF;break;	
	      case Event.RIGHT:zeichen=Zeichen.PFEILRECHTS;break;	
	      case Event.UP:zeichen=Zeichen.PFEILOBEN;break;
		}
	 }
	 this.bearbeiteTaste(zeichen);
}
    public void keyPressed(KeyEvent e){}
    public void keyReleased(KeyEvent e){}
    public void mouseClicked(MouseEvent e){
		if (! e.isMetaDown() )
		{ this.bearbeiteMausKlick(e.getX()-offsetx,e.getY()-offsety);}
		else
		{ this.bearbeiteSpezialKlick(e.getX()-offsetx,e.getY()-offsety);}
	}

    public void mousePressed(MouseEvent e){
		if (! e.isMetaDown() )
		{ this.bearbeiteMausDruck(e.getX()-offsetx,e.getY()-offsety);}
		else
		{ this.bearbeiteMausDruckRechts(e.getX()-offsetx,e.getY()-offsety);}
	}
 
     public void mouseReleased(MouseEvent e){
 		if (! e.isMetaDown() )
		{ this.bearbeiteMausLos(e.getX()-offsetx,e.getY()-offsety);
		}
		else
		{ this.bearbeiteMausLosRechts(e.getX()-offsetx,e.getY()-offsety);}
	}
   public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    public void mouseDragged(MouseEvent e){
	  this.bearbeiteMausBewegt(e.getX()-offsetx,e.getY()-offsety);
	  this.bearbeiteMausGezogen(e.getX()-offsetx,e.getY()-offsety);

	}
    public void mouseMoved(MouseEvent e){
	this.bearbeiteMausBewegt(e.getX()-offsetx,e.getY()-offsety);
	}
	public void windowActivated (WindowEvent e)
	{;}
	public void windowClosed(WindowEvent e)
	{;}
	public void windowDeactivated(WindowEvent e)
	{;}
	public void windowDeiconified(WindowEvent e)
	{;}
	public void windowIconified(WindowEvent e)
	{;}
	public void windowOpened(WindowEvent e)
	{;}
	public void windowClosing(WindowEvent e)
	{;}
	public void componentShown(ComponentEvent e)
	{;}
	public void componentResized(ComponentEvent e)
	{;}
	public void componentHidden(ComponentEvent e)
	{;}
	public void componentMoved(ComponentEvent e)
	{this.bearbeiteFensterBewegt();}

  }