import stiftUndCo.*;
//
//
// NDamen
//
//
public class NDamenIterativ extends EreignisAnwendung
{

	private int[] platzierung;
	private int anzahlDamen;
	private int anzahlLsungen=0;
	

	public static void main(String[] s)
	{
		NDamenIterativ n=new NDamenIterativ(12);
	}


	public NDamenIterativ(int anzahl)
	{
		super(300,200,"Das n-Damen-Problem");
		
		platzierung = new int[anzahl+1];
		anzahlDamen=anzahl;
		
		for (int i=1; i<= anzahl;i++)
		{
			platzierung[i]=0;
		}
	}

	public void bearbeiteMausDruck(int x, int y)
	{
		this.gitter();
		anzahlLsungen=0;
		this.such();
		System.out.println(""+anzahlLsungen);	
	}

	public void zeichneDame(int spalte, int zeile)
	{
				stift.bewegeBis(10*spalte,10*zeile+30);
				stift.normal();
				stift.zeichneKreis(4);

	}
	public void loescheDame(int spalte, int zeile)
	{
			stift.bewegeBis(10*spalte,10*zeile+30);
			stift.radiere();
			stift.zeichneKreis(4);
	}
	public void such()
	{
		int spalte,zeile;
		Keller k;
		Position p;
		boolean ende=false;
		
		k=new Keller();
		
		spalte=1;zeile=1;

		while (spalte > 0)
		{
			// Suche Platz fr Dame in Spalte spalte
			while ((zeile<=anzahlDamen) && !passt(spalte,zeile))
			{
				zeile=zeile+1;
			}
			if (zeile > anzahlDamen) //kein Platz gefunden
			{  	
				spalte=spalte-1;
				if (spalte > 0)
				{
				 zeile=((Position)k.top()).zeile() + 1;
				 this.loescheDame(spalte,zeile-1);
				 k.pop();
				}
			} else //Platz gefunden
			{	//einkellern :
				p=new Position(zeile);
				k.push(p);
				platzierung[spalte]=zeile;
				this.zeichneDame(spalte,zeile);
				// Lsung gefunden ?
				if (spalte==anzahlDamen)
				{
					this.ausgabe();
					anzahlLsungen++;
					System.out.println("L:"+anzahlLsungen);					
					// Darstellung lschen und weiter
					this.loescheDame(spalte,zeile);
					k.pop(); // letzte Dame lschen und zurck zur vorletzten
					spalte=spalte-1;
					zeile=((Position)k.top()).zeile() + 1;
					this.loescheDame(spalte,zeile-1);
					k.pop();
				} else // es geht weiter mit der nchsten Dame
				{
					spalte=spalte+1;
					zeile=1;
				}
			}
		}
	}

	private boolean passt(int i, int j)
	{
		boolean hilf=true, ende=false;
		int k=1;
		if (i==1) return true;
		// pat die i-Dame auf Zeile j ?
		while (hilf && ! ende)
		{
			//Zeile berprfen
			hilf = (platzierung[k]!=j) ;
			k=k+1;
			ende = (k==i);
		}
		// berprfung der absteigenden Diagonalen
		ende=false;
		k=1;
		while (hilf && ! ende)
		{
			//Zeile berprfen
			hilf = (platzierung[k]-k!=j-i) ;
			k=k+1;
			ende = (k==i);
		}
		// berprfung der aufsteigenden Diagonalen
		ende=false;
		k=1;
		while (hilf && ! ende)
		{
			//Zeile berprfen
			hilf = (platzierung[k]+k!=j+i) ;
			k=k+1;
			ende = (k==i);
		}
		return hilf;
	}

	private void ausgabe()
	{
		for (int i=1; i<= anzahlDamen; i++)
		{
			System.out.println(""+platzierung[i]);
		}
	}

	private void gitter()
	{
		for (int i=0; i<= anzahlDamen; i++)
		{
			this.stift().normal();
			this.stift().hoch();
			this.stift().bewegeBis(10*i+5,35);
			this.stift().runter();
			this.stift().bewegeBis(10*i+5,35+anzahlDamen*10);
			this.stift().hoch();

		}
		for (int i=0; i<= anzahlDamen; i++)
		{
			this.stift().normal();
			this.stift().hoch();
			this.stift().bewegeBis(5,10*i+35);
			this.stift().runter();
			this.stift().bewegeBis(anzahlDamen*10+5,10*i+35);
			this.stift().hoch();

		}
	}

}

	class Position
	{
		private int zeile;
		public Position(int pZeile)
		{
			zeile=pZeile;
			
		}
		public int zeile()
		{
			return zeile;
		}
		
	}