import stiftUndCo.*;
import java.awt.*;

public abstract class Figur 
{
	double zHPosition,zVPosition;
	BuntStift hatStift;

	public Figur (double pHPosition, double pVPosition, Color pFarbe)
	{
		zHPosition = pHPosition;
		zVPosition = pVPosition;
		hatStift= new BuntStift();
		hatStift.setzeFarbe(pFarbe);
	}

	public abstract void zeichneDich();
	public abstract void loescheDich();

	public void aktiviereDich()
	{
		this.loescheDich();
		hatStift.setzeLinienBreite(3);
		this.zeichneDich();
	}

	public void deaktiviereDich()
	{
		this.loescheDich();
		hatStift.setzeLinienBreite(1);
		this.zeichneDich();
	}

	public void setzeFarbe (Color pFarbe)
	{
		this.loescheDich();
		hatStift.setzeFarbe(pFarbe);
		this.zeichneDich();
	}

	public void bewegeUm (double dH, double dV)
	{
		zHPosition = dH + zHPosition;
		zVPosition = dV + zVPosition;
	}

	public void bewegeBis (double pHPosition, double pVPosition)
	{
		zHPosition = pHPosition;
		zVPosition = pVPosition;
	}

	public abstract boolean getroffen (double pHPosition, double pVPosition);

	public BuntStift stift()
	{
		return hatStift;
	}

	public double hPosition()
	{
		return zHPosition;
	}

	public double vPosition()
	{
		return zVPosition;
	}

	public void gibFrei()
	{
		hatStift.gibFrei();
	}

}