import stiftUndCo.*;
import java.awt.*;
public class Kreis extends Figur
{
	double zRadius;

	public Kreis (double pRadius, double pHPosition, double pVPosition, Color pFarbe)
	{
		super(pHPosition, pVPosition, pFarbe);
		zRadius = pRadius;
	}

	public void zeichneDich()
	{
		this.stift().hoch();
		this.stift().bewegeBis(this.hPosition(), this.vPosition());
		this.stift().normal();
		this.stift().zeichneKreis(zRadius);
	}

	public void loescheDich()
	{
		this.stift().hoch();
		this.stift().bewegeBis(this.hPosition(), this.vPosition());
		this.stift().radiere();
		this.stift().zeichneKreis(zRadius);
	}

	public boolean getroffen (double pHPosition, double pVPosition)
	{
		return Hilfe.wurzel(Hilfe.quadrat(this.hPosition() - pHPosition)
     + Hilfe.quadrat (this.vPosition() - pVPosition)) <= zRadius;
	}

	public void radiusAendern (double dRadius)
	{
		zRadius = zRadius + dRadius;
	}
}
