import stiftUndCo.*;
import java.awt.*;

public class Lok extends Waggon
{
	private Kreis vorderrad, hinterrad;
	private Quadrat fenster;
	private Rechteck schornstein, kessel, stand;


	public Lok (double pHPosition,double  pVPosition)

	{
		super(pHPosition,pVPosition);
		vorderrad = new Kreis(5, pHPosition + 7, pVPosition, Farbe.ROT);
		hinterrad = new Kreis(5, pHPosition + 37, pVPosition, Farbe.ROT);
		fenster =new Quadrat(10, pHPosition + 29, pVPosition - 35, Farbe.GRUEN);
		schornstein =new Rechteck(22, 20, pHPosition, pVPosition - 20, Farbe.BLAU);
		kessel=new Rechteck(22, 40, pHPosition + 22, pVPosition - 40, Farbe.BLAU);
		stand = new Rechteck(5, 10, pHPosition + 5, pVPosition - 30, Farbe.GELB);      
		
	}

	public void zeichneDich()
	{
		super. zeichneDich();
		fenster.zeichneDich();
		vorderrad.zeichneDich();
		hinterrad.zeichneDich();
		schornstein.zeichneDich();
		kessel.zeichneDich();
		stand.zeichneDich();
	}

	public void loescheDich()
	{
		super.loescheDich();
		fenster.loescheDich();
		vorderrad.loescheDich();
		hinterrad.loescheDich();
		schornstein.loescheDich();
		kessel.loescheDich();
		stand.loescheDich();
	}

	public void bewegeBis (double pHPosition,double  pVPosition)
	{
		super. bewegeBis(pHPosition, pVPosition);
		fenster.bewegeBis(pHPosition + 29, pVPosition - 35);
		vorderrad.bewegeBis(pHPosition + 7, pVPosition);
		hinterrad.bewegeBis(pHPosition + 37, pVPosition);
		schornstein.bewegeBis(pHPosition, pVPosition - 20);
		kessel.bewegeBis(pHPosition + 22, pVPosition - 40);
		stand.bewegeBis(pHPosition + 5, pVPosition - 30);
	}

	public double laenge()
	{
		return 44;
	}

	public void gibFrei()
	{
		schornstein.gibFrei();
		kessel.gibFrei();
		stand.gibFrei();
		vorderrad.gibFrei();
		hinterrad.gibFrei();
		fenster.gibFrei();
		super. gibFrei();
	}
}
