import stiftUndCo.*;
import java.awt.*;

public class Viehwagen extends Waggon
{
	Quadrat vorderteil, hinterteil;
	Kreis	vorderrad, hinterrad;

	public Viehwagen (double pHPosition,double  pVPosition)
	{
		super(pHPosition, pVPosition);
		vorderteil = new Quadrat(22, pHPosition, pVPosition - 22, Farbe.BLAU);
		hinterteil = new Quadrat(22, pHPosition + 22, pVPosition - 22, Farbe.BLAU);
		vorderrad = new Kreis(5, pHPosition + 10, pVPosition, Farbe.ROT);
		hinterrad = new Kreis(5, pHPosition + 34, pVPosition, Farbe.ROT);
	}

	public void zeichneDich()
	{
		super. zeichneDich();
		vorderteil.zeichneDich();
		hinterteil.zeichneDich();
		vorderrad.zeichneDich();
		hinterrad.zeichneDich();
	}

	public void loescheDich()
	{
		super. loescheDich();
		vorderteil.loescheDich();
		hinterteil.loescheDich();
		vorderrad.loescheDich();
		hinterrad.loescheDich();
	}

	public void bewegeBis (double pHPosition,double  pVPosition)
	{
		super. bewegeBis(pHPosition, pVPosition);
		vorderteil.bewegeBis(pHPosition, pVPosition - 22);
		hinterteil.bewegeBis(pHPosition + 22, pVPosition - 22);
		vorderrad.bewegeBis(pHPosition + 10, pVPosition);
		hinterrad.bewegeBis(pHPosition + 34, pVPosition);
	}

	public double laenge()
	{
		return 44;
	}

	public void gibFrei()
	{
		hinterrad.gibFrei();
		vorderrad.gibFrei();
		hinterteil.gibFrei();
		vorderteil.gibFrei();
		super. gibFrei();
	}
}